unit unit1;

{$mode delphi}{$H+}

interface

uses
  Windows, Classes, SysUtils, FileUtil, Forms, Controls, Dialogs, StdCtrls,
  ExtCtrls, XMLPropStorage, ComObj;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    CheckBox1: TCheckBox;
    ComboBox1: TComboBox;
    Label2: TLabel;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    OpenDialog1: TOpenDialog;
    OpenDialog2: TOpenDialog;
    XMLPropStorage1: TXMLPropStorage;
    procedure FormCreate(Sender: TObject);
    procedure StartClick(Sender: TObject);
    procedure OpenFileDialogClick(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }


procedure TForm1.StartClick(Sender: TObject);
var
  formatter : Variant;
  xml, xsl, outputfile :  WideString;
  rc : integer;

  function MakeURI(s: WideString) : WideString;
  begin
    result := 'file:///'+StringReplace(s,'\','/',[rfReplaceAll]);
  end;

  function MakeOutputFilename(s: WideString) : WideString;
  begin
    case ComboBox1.ItemIndex of
    0 : result := ChangeFileExt(s,'.PDF');
    1 : result := ChangeFileExt(s,'.PS');
    2 : result := ChangeFileExt(s,'.XEP');
    else result := ChangeFileExt(s,'.PDF');
    end; {case}
  end;

  function MakeMimeType : WideString;
  begin
    case ComboBox1.ItemIndex of
    0 : result := 'application/pdf';
    1 : result := 'application/postscript';
    2 : result := 'application/xep';
    else result := 'application/pdf';
    end; {case}
  end;

begin
  formatter := CreateOleObject('XEPCOM.Formatter');
  xml := LabeledEdit1.Text;
  xsl := LabeledEdit2.Text;
  outputfile := MakeOutputFilename(xml);
  if FileExists(outputfile) then
     DeleteFile(outputfile);

  try
    rc := formatter.LoadStylesheet(xsl);
  except
    ShowMessage(Format('ERROR %d: loading stylesheet failed!',[rc]));
    if rc <> 0 then exit
  end;

  try
    rc := formatter.Format(xml,MakeURI(xml),MakeMimeType, outputfile);
  except
    ShowMessage(Format('ERROR %d: Format failed!',[rc]));
    if rc <> 0 then exit
  end;

  if FileExists(outputfile) then
  begin
    if CheckBox1.Checked then
       ShellExecute(Self.Handle, PChar ('open'), PChar (String(outputfile)), PChar (''), PChar (''), 0)
    else
       ShowMessage('Formatting completed sucessfully!'+#13#10+outputfile + ' successfully created!')
  end
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
//
  XMLPropStorage1.Filename := ExtractFilePath(Application.exeName)+'Test_XEPCOM.XML';
end;

procedure TForm1.OpenFileDialogClick(Sender: TObject);
begin
  if Sender is TButton then
     case (Sender as TButton).Tag of
     0: if OpenDialog1.execute then
           LabeledEdit1.Text := OpenDialog1.Filename;
     1: if OpenDialog2.execute then
           LabeledEdit2.Text := OpenDialog2.Filename;
     end;
end;

end.

